和大神们学习每天一题(leetcode)-Intersection of Two Linked Lists

Write a program to find the node at which the intersection of two singly linked lists begins.


For example, the following two linked lists:

A:          a1 → a2
                   ↘
                     c1 → c2 → c3
                   ↗            
B:     b1 → b2 → b3

begin to intersect at node c1.


Notes:

  • If the two linked lists have no intersection at all, return null.
  • The linked lists must retain their original structure after the function returns.
  • You may assume there are no cycles anywhere in the entire linked structure.
  • Your code should preferably run in O(n) time and use only O(1) memory.

Credits:
Special thanks to @stellari for adding this problem and creating all test cases.

There are many solutions to this problem:

  • Brute-force solution (O(mn) running time, O(1) memory):

    For each node ai in list A, traverse the entire list B and check if any node in list B coincides with ai.

  • Hashset solution (O(n+m) running time, O(n) or O(m) memory):

    Traverse list A and store the address / reference to each node in a hash set. Then check every node bi in list B: if bi appears in the hash set, then bi is the intersection node.

  • Two pointer solution (O(n+m) running time, O(1) memory):
    • Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.
    • When pA reaches the end of a list, then redirect it to the head of B (yes, B, that's right.); similarly when pB reaches the end of a list, redirect it the head of A.
    • If at any point pA meets pB, then pA/pB is the intersection node.
    • To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node '9'. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.
    • If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.
class Solution 
{
public:
	ListNode *getIntersectionNode(ListNode *headA, ListNode *headB) //双指针法
	{
		int nLenA = 1, nLenB = 1;
		if (headA == NULL || headB == NULL)
			return NULL;
		ListNode *PointA = headA, *PointB = headB;
		while (PointA->next != NULL)//遍历A链表,计算链表长度
		{
			nLenA++;
			PointA = PointA->next;
		}
		while (PointB->next != NULL)//遍历B链表,计算链表长度
		{
			nLenB++;
			PointB = PointB->next;
		}
		PointA = headA;
		PointB = headB;
		if (nLenA >= nLenB)
		{
			for (int nTemp = 0; nTemp < nLenA - nLenB; nTemp++)
			{
				PointA = PointA->next;
			}
			for (int nTemp = 0; nTemp < nLenB; nTemp++)
			{
				if (PointA == PointB)
				{
					return PointA;
				}
				PointA = PointA->next;
				PointB = PointB->next;
			}
			return NULL;
		}
		else
		{
			for (int nTemp = 0; nTemp < nLenB - nLenA; nTemp++)
			{
				PointB = PointB->next;
			}
			for (int nTemp = 0; nTemp < nLenA; nTemp++)
			{
				if (PointA == PointB)
				{
					return PointA;
				}
				PointA = PointA->next;
				PointB = PointB->next;
			}
			return NULL;
		}
	}
};


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值